//+------------------------------------------------------------------+
//|                                            PivotPoint[v_2_0].mq4 |
//|                                                      4555 |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "4555"
#property link      "http://www.metaquotes.net"
extern int Days_in_history=3;                                                          //-     
extern string AsiaOpen   = "02:00",                                                    //   
              EuropaOpen = "09:00",                                                    //             
              UsaOpen    = "15:30",                                                    //             
              PacificOpen= "22:00";                                                    //                                                                                   
double        SHighi,                                                                  //   
              SLowi,                                                                   //
              SClosei;                                                                 //   
int           ty,                                                                      //   
              tm,                                                                      //
              td,                                                                      //
              c,                                                                       //
              a,                                                                       //
              SessNum,                                                                 // 
              SStart,                                                                  //
              SEnd;                                                                    //
datetime      Intrday_sess_Start,                                                      //
              Intrday_sess_End,                                                        //
              SessStartCount,                                                          //
              SessEndCount,                                                            //
              TimeCurr,                                                                //
              EuOpen,                                                                  //
              UsOpen,                                                                  //
              AsOpen,                                                                  //
              PoOpen;                                                                  //   
#property indicator_chart_window
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
TimeCurr=TimeCurrent();                                                                //
ty=TimeYear(TimeCurr);                                                                 //
tm=TimeMonth(TimeCurr);                                                                //
td=TimeDay(TimeCurr);                                                                  //
EuOpen   = StrToTime (ty+"."+tm+"."+td+" "+EuropaOpen);                                //      
UsOpen   = StrToTime (ty+"."+tm+"."+td+" "+UsaOpen);                                   //
AsOpen   = StrToTime (ty+"."+tm+"."+td+" "+AsiaOpen);                                  //
PoOpen   = StrToTime (ty+"."+tm+"."+td+" "+PacificOpen);                               //   
//--------------------------------------------------------------------------------------                      
c=1;                                                                                   //     
for (a=1;a<=Days_in_history;a++){                                                      //-    - 
SessNum=1;                                                                             //      =1
  while (SessNum<=5){                                                                  //        
   
   if (TimeDayOfWeek  (EuOpen)==0){                                                    //
                         EuOpen=EuOpen-172800;                                         //
                         AsOpen=AsOpen-172800;                                         //
                         UsOpen=UsOpen-172800;                                         //
                         PoOpen=PoOpen-172800;}                                        //
   if (TimeDayOfWeek   (TimeCurr)==0){
     Intrday_sess_Start=Intrday_sess_Start-172800;
     SessNum=1;
     }
                        
if (TimeCurr<UsOpen && TimeCurr>EuOpen){                                //       
   Intrday_sess_Start=EuOpen;                                           //     
   Intrday_sess_End=UsOpen;                                             //    
   SessStartCount=AsOpen;                                               //     
   SessEndCount=EuOpen;
   SessNum=3;
   }                       
if (TimeCurr<EuOpen && TimeCurr>AsOpen){
   Intrday_sess_Start=AsOpen;                                           //    (   )
   Intrday_sess_End=EuOpen;                                             //    
   SessStartCount=StrToTime (ty+"."+tm+"."+(td-a)+" "+PacificOpen);     //    (   )
   SessEndCount=AsOpen;                                                 //     
   SessNum=4;
   }
if (TimeCurr<AsOpen && TimeCurr>StrToTime (ty+"."+tm+"."+(td-a)+" "+PacificOpen)){
   Intrday_sess_Start=StrToTime (ty+"."+tm+"."+(td-a)+" "+PacificOpen);
   Intrday_sess_End=AsOpen;
   SessStartCount=StrToTime (ty+"."+tm+"."+(td-a)+" "+UsaOpen);
   SessEndCount=StrToTime (ty+"."+tm+"."+(td-a)+" "+PacificOpen);
   SessNum=5;
   }
if (TimeCurr<StrToTime (ty+"."+tm+"."+(td+1)+" "+AsiaOpen) && TimeCurr>PoOpen){
   Intrday_sess_Start=PoOpen;
   Intrday_sess_End=StrToTime (ty+"."+tm+"."+(td+1)+" "+AsiaOpen);
   SessStartCount=UsOpen;
   SessEndCount=PoOpen;
   SessNum=1;
   }
if (TimeCurr<PoOpen && TimeCurr>UsOpen){
   Intrday_sess_Start=UsOpen;
   Intrday_sess_End=PoOpen;
   SessStartCount=EuOpen;
   SessEndCount=UsOpen;
   SessNum=2;
}                                                               
 ObjectCreate ("sess2"+c,OBJ_VLINE,0,EuOpen,0);                             //  
 ObjectCreate ("sess3"+c,OBJ_VLINE,0,UsOpen,0);
 ObjectCreate ("sess1"+c,OBJ_VLINE,0,AsOpen,0);
 ObjectCreate ("sess4"+c,OBJ_VLINE,0,PoOpen,0);


int         SStart= iBarShift (NULL,PERIOD_M1,SessStartCount),          //   
             SEnd  = iBarShift (NULL,PERIOD_M1,SessEndCount);           //   

double                SHighi =High [SStart];
while (SStart>=SEnd){
                        if (SHighi < High[SEnd])
                            SHighi = High [SEnd];
                           SEnd++;}
ObjectCreate ("PP"+c, OBJ_TREND,0,Intrday_sess_Start,SHighi,Intrday_sess_End,SHighi);
                  ObjectSet ("PP"+c,OBJPROP_COLOR,Blue);
                  ObjectSet ("PP"+c,OBJPROP_RAY,false);
                  ObjectSet ("PP"+c,OBJPROP_WIDTH,1);
                  ObjectSet ("PP"+c,OBJPROP_STYLE,STYLE_DASH);

c++;                                                                        //   
TimeCurr=Intrday_sess_Start-60;                                             //        
SessNum++;
}
                                                                           //             
EuOpen   = EuOpen-86400;                                                    //       
UsOpen   = UsOpen-86400;                                                    //          
AsOpen   =  AsOpen-86400;                                                   //        
PoOpen   =  PoOpen-86400;                                                   //   
}  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
int d=1;
while (d<=500){
  ObjectDelete ("sess"+d);
  ObjectDelete ("PP"+d);
 d++;}
  Comment (" ");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

//----
   return(0);
  }
//+------------------------------------------------------------------+